package io.tswf.groovy.bettergroovy.extensions.instance

import groovy.transform.stc.ClosureParams
import groovy.transform.stc.FromString

import java.lang.reflect.Array
import java.util.stream.Collectors
import java.util.stream.Stream

class AdditionalArrayMethods {
    static <T> boolean isNullOrEmpty(T[] arr) {
        return arr == null || arr.length == 0
    }

    static <T> boolean isNotNullOrEmpty(T[] arr) {
        return arr != null && arr.length != 0
    }

    static <T> Stream<T> stream(T[] arr) {
        return Arrays.stream(arr)
    }

    static <T> Stream<T> parallelStream(T[] arr) {
        return Arrays.asList(arr).parallelStream()
    }

    static <R, T> List<R> map(T[] arr, @ClosureParams(value= FromString.class, options = "T") Closure<R> mapper) {
        return Arrays.stream(arr).map(mapper).collect(Collectors.toList())
    }

    static <T, R> R[] mapToArray(T[] arr, @ClosureParams(value= FromString.class, options = "T") Closure<R> mapper, Class<R> classOfNewArr) {
        def array = Array.newInstance(classOfNewArr, arr.length)

        for (def i1 = 0; i1 < arr.length; i1 ++) {
            Array.set(array, i1, mapper(arr[i1]))
        }

        return (R[]) array
    }
}
