package io.tswf.groovy.bettergroovy.extensions.instance

import java.awt.Graphics
import java.awt.image.BufferedImage

class AdditionalBufferedImageMethods {
    static BufferedImage combine(BufferedImage originalImage, BufferedImage additionalImage) {
        def g = (Graphics) null

        try {
            def w = Math.max(originalImage.getWidth(), additionalImage.getWidth())
            def h = Math.max(originalImage.getHeight(), additionalImage.getHeight())
            def combined = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB)
            g = combined.getGraphics()
            g.drawImage(originalImage, 0, 0, null)
            g.drawImage(additionalImage, 0, 0, null)

            return combined
        } finally {
            if (g != null)
                g.dispose()
        }
    }
}
