package io.tswf.groovy.bettergroovy.extensions.instance

import groovy.transform.stc.ClosureParams
import groovy.transform.stc.FromString

import java.util.function.Consumer

class AdditionalObjectMethods {

    static <T> T let(T obj, @ClosureParams(value= FromString.class, options = "T") Closure func) {
        func(obj)
        return obj
    }

    static <T> T letOrElse(T obj, @ClosureParams(value= FromString.class, options = "T") Consumer func, Closure elseFunc) {
        if (obj != null) {
            func(obj)
        } else {
            elseFunc()
        }
    }

    static <R, T> R mapTo(T instance, @ClosureParams(value= FromString.class, options = "T") Closure<R> mapper) {
        return mapper(instance)
    }
}
