package io.tswf.groovy.bettergroovy.extensions.instance

import groovy.transform.stc.ClosureParams
import groovy.transform.stc.SimpleType

class AdditionalProcessMethods {

    static Process forOutput(
            Process proc,
            @ClosureParams(value = SimpleType.class, options = "java.lang.String")
            Closure lineProcessor
    ) {
        def scanner = new Scanner(proc.inputStream)
        while (scanner.hasNextLine()) {
            lineProcessor(scanner.nextLine())
        }
        scanner.close()

        return proc
    }

    static boolean isAlive(Process proc) {
        try {
            proc.exitValue()
            return false
        } catch (Throwable ignore) {}

        return true
    }
}
