package io.tswf.groovy.bettergroovy.extensions.instance

import groovy.transform.stc.ClosureParams
import groovy.transform.stc.SimpleType

class AdditionalRuntimeMethods {

    static Process executeCmd(
            Runtime runtime,
            List<String> command,
            @ClosureParams(value = SimpleType.class, options = "java.lang.ProcessBuilder")
            @DelegatesTo(value = ProcessBuilder, strategy = Closure.DELEGATE_FIRST)
            Closure builderAdditional = {}
    ) {
        def procBuilder = new ProcessBuilder(command)
            .directory(new File("./"))
            .redirectErrorStream(true)

        if (builderAdditional != null) {
            builderAdditional(procBuilder)
        }

        return procBuilder.start()
    }
}
