package io.tswf.groovy.bettergroovy.extensions.instance.ast

import org.codehaus.groovy.ast.AnnotatedNode
import org.codehaus.groovy.ast.AnnotationNode
import org.codehaus.groovy.ast.ClassHelper
import org.codehaus.groovy.ast.ClassNode

class AdditionalAnnotatedNodeMethods {
    static boolean hasAnnotation(AnnotatedNode self, ClassNode annotationType) {
        return self.annotations.any {it.classNode.name == annotationType.name}
    }

    static boolean hasAnnotation(AnnotatedNode self, Class<?> annotationClass) {
        return hasAnnotation(self, ClassHelper.make(annotationClass))
    }

    static AnnotationNode addAnnotation(AnnotatedNode self, Class<?> type) {
        return self.addAnnotation(ClassHelper.make(type))
    }
}
