package io.tswf.groovy.bettergroovy.extensions.instance.ast

import org.codehaus.groovy.ast.ClassHelper
import org.codehaus.groovy.ast.ClassNode

class AdditionalClassNodeMethods {
    static boolean isPrimitive(ClassNode self) {
        return ClassHelper.isPrimitiveType(self)
    }


    static boolean isAssignableFrom(ClassNode self, ClassNode from) {
        def isFirstPrimitive = ClassHelper.isPrimitiveType(from)
        def isSecondPrimitive = ClassHelper.isPrimitiveType(self)
        if (isFirstPrimitive != isSecondPrimitive) {
            def object1Type = isFirstPrimitive ? ClassHelper.getWrapper(from) : from
            def object2Type = isSecondPrimitive ? ClassHelper.getWrapper(self) : self

            return isAssignableFrom(object1Type, object2Type)
        }

        def parent = from
        while (parent != null) {
            if (parent.name == self.name) {
                return true
            }

            if (parent?.interfaces?.any {it.name == self.name}) {
                return true
            }

            parent = parent.superClass
        }

        return false
    }
}
