package io.tswf.groovy.bettergroovy.extensions.instance.ast


import org.codehaus.groovy.ast.MethodNode
import org.codehaus.groovy.ast.VariableScope
import org.codehaus.groovy.ast.expr.ClosureExpression
import org.codehaus.groovy.ast.stmt.BlockStatement

import java.lang.reflect.Modifier

import static org.codehaus.groovy.ast.tools.GeneralUtils.closureX

class AdditionalMethodNodeMethods {
    static ClosureExpression extractCodeToClosure(MethodNode mn) {
        def methodCode = mn.code
        if (methodCode instanceof BlockStatement) {

            // Для того, чтобы вытянуть код метода в closure, требуется его параметры сделать расшаренными, чтобы они были доступны по ссылке (аналог AtomicReference)
            for (def param : mn.parameters) {
                param.setClosureSharedVariable(true)
            }

            def clos = closureX(methodCode)
            def scope = new VariableScope(methodCode.variableScope)
            scope.setInStaticContext(Modifier.isStatic(mn.modifiers))

            methodCode.variableScope.referencedLocalVariablesIterator.each {
                scope.putReferencedLocalVariable(it)
            }

            methodCode.variableScope.referencedLocalVariablesIterator.each {
                scope.putReferencedClassVariable(it)
            }

            clos.setVariableScope(scope)

            return clos
        }

        throw new IllegalArgumentException("The method node '$mn' code is not a block statement!")
    }
}
