package io.tswf.groovy.bettergroovy.extensions.statics

import java.util.concurrent.CompletableFuture
import java.util.concurrent.Future

class AdditionalGlobalStaticMethods {

    static <T> T await(Object self, Future<T> future) {
        return awaitFuture(self, future)
    }

    static <T> T awaitFuture(Object self, Future<T> future) {
        if (future == null)
            return null

        return future.get()
    }

    static <T> T asyncAwait(Object self, Closure<T> action) {
        return async(self, action).get()
    }

    static <T> CompletableFuture<T> async(Object self, Closure<T> action) {
        return CompletableFuture.supplyAsync {
            return action()
        }
    }
}
